import sys
import math
import simres as sim

if __name__ == "__main__":
    ret = sim.load_result(r'D:\your\model\name.DATA','u','s')
    if ret!=0:
        if ret>0:
            print(ret)
        else:
            print("Error code:"+ret)
    sn = sim.sm_getn_wells()
    #print(sn)
    if len(sn)==0:
        print("There is no wells.")
        sim.clear()
        sys.exit()
    ### Below few lines used for DEBUG.
    #wvn = sim.sm_getn_wvectors(sn[0])
    #print(wvn)
    tv = sim.sm_getv_time()
    print("Number of Time Steps:",len(tv))
    ###******************
    # Set vector names  *
    ###******************
    vc=["WBHP","WWCT"]
    for i in range(0,len(vc)):
        vn = vc[i]
        print("------------------------------------------------")
        print("*** Checking history-matching result:"+vn)
        print("------------------------------------------------")
        for j in range(0, len(sn)):
            wn = sn[j]
            wv0 = sim.sm_getv_well(wn,vn+"H")
            wv1 = sim.sm_getv_well(wn,vn)
            rms = 0
            ###******************************************
            # 这里使用了均方根误差，可以替换为其它算法  *
            ###******************************************         
            for k in range(0,len(wv0)):
                if abs(wv0[k])>0.00001:
                    rms += pow((wv0[k]-wv1[k])/wv0[k],2)
                else:
                    rms += pow((wv0[k]-wv1[k])/0.00001,2)
            rms /=len(wv0)
            rms = math.sqrt(rms)
            print("{0: >8} : {1:.3f}%".format(wn,rms))
    sim.clear()
    
